'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }(); /*
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Parsec
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * https://github.com/d-plaindoux/parsec
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      *
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Copyright (c) 2016 Didier Plaindoux
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      * Licensed under the LGPL2 license.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                      */

var _parser = require('../parsec/parser.js');

var _parser2 = _interopRequireDefault(_parser);

var _unit = require('../data/unit.js');

var _unit2 = _interopRequireDefault(_unit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// (string -> 'a,string -> 'a,number -> 'a,string -> 'a,char -> 'a) -> GenlexFactory 'a
function GenlexFactory(keyword, ident, number, string, char) {
    this.keyword = keyword;
    this.ident = ident;
    this.number = number;
    this.string = string;
    this.char = char;
}

var Genlex = function () {

    // [String] -> Genlex

    function Genlex(keywords) {
        _classCallCheck(this, Genlex);

        this.keywordParser = (keywords || []).reduce(function (p, s) {
            return _parser2.default.string(s).or(p);
        }, _parser2.default.error);

        var idletter = _parser2.default.letter.or(_parser2.default.char('_')).or(_parser2.default.digit);
        this.identParser = _parser2.default.letter.then(idletter.optrep());
    }

    // unit -> Parser char char


    _createClass(Genlex, [{
        key: 'space',
        value: function space() {
            return _parser2.default.charIn(" \r\n\f\t");
        }

        // unit -> Parser unit char

    }, {
        key: 'spaces',
        value: function spaces() {
            return this.space().optrep().map(function () {
                return _unit2.default;
            });
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'keyword',
        value: function keyword(f) {
            return this.keywordParser.map(function (s) {
                return f.keyword(s);
            });
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'ident',
        value: function ident(f) {
            return this.identParser.map(function (r) {
                return f.ident([r[0]].concat(r[1]).join(''));
            });
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'number',
        value: function number(f) {
            return _parser2.default.numberLiteral.map(function (s) {
                return f.number(s);
            });
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'string',
        value: function string(f) {
            return _parser2.default.stringLiteral.map(function (s) {
                return f.string(s);
            });
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'char',
        value: function char(f) {
            return _parser2.default.charLiteral.map(function (s) {
                return f.char(s);
            });
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'token',
        value: function token(f) {
            return this.keyword(f).or(this.ident(f)).or(this.number(f)).or(this.string(f)).or(this.char(f));
        }

        // GenLexFactory 'a -> Parser 'a char

    }, {
        key: 'tokenBetweenSpaces',
        value: function tokenBetweenSpaces(f) {
            return this.spaces().thenRight(this.token(f)).thenLeft(this.spaces());
        }

        // GenLexFactory 'a -> Parser ['a] char

    }, {
        key: 'tokens',
        value: function tokens(f) {
            return this.tokenBetweenSpaces(f).optrep().thenLeft(_parser2.default.eos);
        }
    }]);

    return Genlex;
}();

exports.default = {
    factory: function factory(keyword, ident, number, string, char) {
        return new GenlexFactory(keyword, ident, number, string, char);
    },
    generator: function generator(keywords) {
        return new Genlex(keywords);
    }
};
//# sourceMappingURL=genlex.js.map